﻿
namespace BcfSampleConsole {

    public partial class SampleModel : CalculationWorks.FreeEdition.BusinessModel.BcfDataSet {
        
        private static CalculationWorks.FreeEdition.BusinessModel.Design.BcfDataSetSetup AddTableFactory(CalculationWorks.FreeEdition.BusinessModel.Design.BcfDataSetSetup dataSetSetup) {
            dataSetSetup.BehaviorItems.Add(GetTableFactory());
            return dataSetSetup;
        }

        public SampleModel(BcfSampleConsole.SampleModelSetup dataSetSetup)
            : base(AddTableFactory(dataSetSetup)) {
			CausewayTable = (CausewayTable)Tables["Causeway"];
			SegmentTable = (SegmentTable)Tables["Segment"];
			CausewayTable.InitializeSchemaProperties();
			SegmentTable.InitializeSchemaProperties();
            Initialize();
        }
        partial void Initialize();
		public CausewayTable CausewayTable { get; private set; }
		public SegmentTable SegmentTable { get; private set; }
		private static CalculationWorks.FreeEdition.BusinessModel.Behaviors.BcfDataSetTableFactory GetTableFactory() {
			CalculationWorks.FreeEdition.BusinessModel.Behaviors.BcfDataSetTableFactory factory = new CalculationWorks.FreeEdition.BusinessModel.Behaviors.BcfDataSetTableFactory();
			factory.Register("Causeway", (builder) => new CausewayTable(builder));
			factory.Register("Segment", (builder) => new SegmentTable(builder));
			return factory;
		}
	}

    public partial class CausewayTable : CalculationWorks.FreeEdition.BusinessModel.BcfTable<CausewayRow> {
        public CalculationWorks.FreeEdition.BusinessModel.BcfColumn WidthColumn { get; private set; }
        public CalculationWorks.FreeEdition.BusinessModel.BcfColumn SizeColumn { get; private set; }
        public CalculationWorks.FreeEdition.BusinessModel.BcfRelation ParentRelationCausewaySegment { get; private set; }
		public void InitializeSchemaProperties() {
            WidthColumn = Columns["Width"];
            SizeColumn = Columns["Size"];
            ParentRelationCausewaySegment = ParentRelations["CausewaySegment"];
		}
        public CausewayTable(CalculationWorks.FreeEdition.BusinessModel.BcfTableBuilder builder) : base(builder) { 
		}
        protected override CausewayRow CreateRow(CalculationWorks.FreeEdition.BusinessModel.BcfRowBuilder builder) {
            return new CausewayRow(builder);
        }
        public new CausewayRow AddNewRow() {
            return AddNewRow(null, true);
        }
        public new CausewayRow AddNewRow(System.Collections.Generic.Dictionary<string, object> initialValues) {
            return AddNewRow(initialValues, true);
        }
        public new CausewayRow AddNewRow(System.Collections.Generic.Dictionary<string, object> initialValues, bool optimistic) {
            return (CausewayRow)base.AddNewRow(initialValues, optimistic);
        }
        public new CausewayRow CreateNewRow() {
            return (CausewayRow)base.CreateNewRow();
        }
        public new CausewayRow Load(object[] values) {
            return (CausewayRow)base.Load(values, true);
        }
        public new CausewayRow Load(object[] values, bool optimistic) {
            return (CausewayRow)base.Load(values, optimistic);
        }
    }

    public partial class CausewayRow : CalculationWorks.FreeEdition.BusinessModel.BcfRow {
        protected internal CausewayRow(CalculationWorks.FreeEdition.BusinessModel.BcfRowBuilder builder) : base(builder) { }

		public new CausewayTable GetTable() {
			return (CausewayTable)base.GetTable();
		}
        public decimal Width {
            get { return (decimal)base[GetTable().WidthColumn].Value;}
            set { base[GetTable().WidthColumn].Value = value; }
		}
        public decimal? Size {
            get { return (decimal?)base[GetTable().SizeColumn].Value;}
		}
        public System.Collections.Generic.IEnumerable<SegmentRow> GetCausewaySegmentRows() {
            return System.Linq.Enumerable.Cast<SegmentRow>(this.GetRelatedRowsCell("CausewaySegment").ChildRows);
        }

        public void AddCausewaySegmentRow(SegmentRow row){
            this.GetRelatedRowsCell("CausewaySegment").AddChildRow(row);
        }
    }
    public partial class SegmentTable : CalculationWorks.FreeEdition.BusinessModel.BcfTable<SegmentRow> {
        public CalculationWorks.FreeEdition.BusinessModel.BcfColumn LengthColumn { get; private set; }
        public CalculationWorks.FreeEdition.BusinessModel.BcfColumn SizeColumn { get; private set; }
        public CalculationWorks.FreeEdition.BusinessModel.BcfRelation ChildRelationCausewaySegment { get; private set; }
		public void InitializeSchemaProperties() {
            LengthColumn = Columns["Length"];
            SizeColumn = Columns["Size"];
            ChildRelationCausewaySegment = ChildRelations["CausewaySegment"];
		}
        public SegmentTable(CalculationWorks.FreeEdition.BusinessModel.BcfTableBuilder builder) : base(builder) { 
		}
        protected override SegmentRow CreateRow(CalculationWorks.FreeEdition.BusinessModel.BcfRowBuilder builder) {
            return new SegmentRow(builder);
        }
        public new SegmentRow AddNewRow() {
            return AddNewRow(null, true);
        }
        public new SegmentRow AddNewRow(System.Collections.Generic.Dictionary<string, object> initialValues) {
            return AddNewRow(initialValues, true);
        }
        public new SegmentRow AddNewRow(System.Collections.Generic.Dictionary<string, object> initialValues, bool optimistic) {
            return (SegmentRow)base.AddNewRow(initialValues, optimistic);
        }
        public new SegmentRow CreateNewRow() {
            return (SegmentRow)base.CreateNewRow();
        }
        public new SegmentRow Load(object[] values) {
            return (SegmentRow)base.Load(values, true);
        }
        public new SegmentRow Load(object[] values, bool optimistic) {
            return (SegmentRow)base.Load(values, optimistic);
        }
    }

    public partial class SegmentRow : CalculationWorks.FreeEdition.BusinessModel.BcfRow {
        protected internal SegmentRow(CalculationWorks.FreeEdition.BusinessModel.BcfRowBuilder builder) : base(builder) { }

		public new SegmentTable GetTable() {
			return (SegmentTable)base.GetTable();
		}
        public decimal Length {
            get { return (decimal)base[GetTable().LengthColumn].Value;}
            set { base[GetTable().LengthColumn].Value = value; }
		}
        public decimal Size {
            get { return (decimal)base[GetTable().SizeColumn].Value;}
		}
        public CausewayRow CausewayRow {
            get { return (CausewayRow)this.GetRelatedRowCell("CausewaySegment").ParentRow; }
            set { this.GetRelatedRowCell("CausewaySegment").ParentRow = value; }
        }
    }
} // namespace