﻿namespace BcfSampleConsole {
	public partial class SampleModelSetup : CalculationWorks.FreeEdition.BusinessModel.Design.BcfDataSetSetup {
	    public SampleModelSetup() : base("SampleModel") {
	        InitSetup(this);
	    }
		private static void InitSetup(SampleModelSetup dss) {
			// Causeway
			CalculationWorks.FreeEdition.BusinessModel.Design.BcfTableSetup causewayTable = dss.AddTable("Causeway");
			// Causeway.Width
			CalculationWorks.FreeEdition.BusinessModel.Design.BcfColumnSetup causewayTableWidthColumn = causewayTable.AddColumn("Width");
			causewayTableWidthColumn.BehaviorItems.Add(new CalculationWorks.FreeEdition.BusinessModel.Behaviors.BcfColumnValueSetter());
			causewayTableWidthColumn.BehaviorItems.Add(new CalculationWorks.FreeEdition.BusinessModel.Behaviors.BcfColumnType(typeof(decimal)));
			causewayTableWidthColumn.BehaviorItems.Add(new CalculationWorks.FreeEdition.BusinessModel.Behaviors.BcfColumnTypeConstraint<decimal>());
			causewayTableWidthColumn.BehaviorItems.Add(new CalculationWorks.FreeEdition.BusinessModel.Behaviors.BcfColumnNotNullConstraint());
			causewayTableWidthColumn.BehaviorItems.Add(new CalculationWorks.FreeEdition.BusinessModel.Behaviors.BcfColumnDefaultValueSource<decimal>());
			// Causeway.Size
			CalculationWorks.FreeEdition.BusinessModel.Design.BcfColumnSetup causewayTableSizeColumn = causewayTable.AddColumn("Size");
			causewayTableSizeColumn.BehaviorItems.Add(new CalculationWorks.FreeEdition.BusinessModel.Behaviors.BcfColumnValueSetter() { CanSet = false } );
			causewayTableSizeColumn.BehaviorItems.Add(new CalculationWorks.FreeEdition.BusinessModel.Behaviors.BcfColumnType(typeof(decimal?)));
			causewayTableSizeColumn.BehaviorItems.Add(new CalculationWorks.FreeEdition.BusinessModel.Behaviors.BcfColumnTypeConstraint<decimal>());
			// Segment
			CalculationWorks.FreeEdition.BusinessModel.Design.BcfTableSetup segmentTable = dss.AddTable("Segment");
			// Segment.Length
			CalculationWorks.FreeEdition.BusinessModel.Design.BcfColumnSetup segmentTableLengthColumn = segmentTable.AddColumn("Length");
			segmentTableLengthColumn.BehaviorItems.Add(new CalculationWorks.FreeEdition.BusinessModel.Behaviors.BcfColumnValueSetter());
			segmentTableLengthColumn.BehaviorItems.Add(new CalculationWorks.FreeEdition.BusinessModel.Behaviors.BcfColumnType(typeof(decimal)));
			segmentTableLengthColumn.BehaviorItems.Add(new CalculationWorks.FreeEdition.BusinessModel.Behaviors.BcfColumnTypeConstraint<decimal>());
			segmentTableLengthColumn.BehaviorItems.Add(new CalculationWorks.FreeEdition.BusinessModel.Behaviors.BcfColumnNotNullConstraint());
			segmentTableLengthColumn.BehaviorItems.Add(new CalculationWorks.FreeEdition.BusinessModel.Behaviors.BcfColumnDefaultValueSource<decimal>());
			// Segment.Size
			CalculationWorks.FreeEdition.BusinessModel.Design.BcfColumnSetup segmentTableSizeColumn = segmentTable.AddColumn("Size");
			segmentTableSizeColumn.BehaviorItems.Add(new CalculationWorks.FreeEdition.BusinessModel.Behaviors.BcfColumnValueSetter() { CanSet = false } );
			segmentTableSizeColumn.BehaviorItems.Add(new CalculationWorks.FreeEdition.BusinessModel.Behaviors.BcfColumnType(typeof(decimal)));
			segmentTableSizeColumn.BehaviorItems.Add(new CalculationWorks.FreeEdition.BusinessModel.Behaviors.BcfColumnTypeConstraint<decimal>());
			segmentTableSizeColumn.BehaviorItems.Add(new CalculationWorks.FreeEdition.BusinessModel.Behaviors.BcfColumnNotNullConstraint());
			segmentTableSizeColumn.BehaviorItems.Add(new CalculationWorks.FreeEdition.BusinessModel.Behaviors.BcfColumnDefaultValueSource<decimal>());
			CalculationWorks.FreeEdition.BusinessModel.Design.BcfRelationSetup causewaySegmentRelation = dss.AddRelation("CausewaySegment", causewayTable , segmentTable, CalculationWorks.FreeEdition.BusinessModel.BcfRelationRule.NoAction, CalculationWorks.FreeEdition.BusinessModel.BcfRelationRule.Cascade);
			{
				// Causeway.Size
				CalculationWorks.FreeEdition.BusinessModel.Design.BcfFunctionSetup f = causewayTableSizeColumn.SetFunction<BcfSampleConsole.SumFunction>();
				f.AllowExecuteParallel = false;
				CalculationWorks.FreeEdition.BusinessModel.Design.BcfParameterSetup p1 = f.AddParameter("Values", "+CausewaySegment.Size");
				p1.BehaviorItems.Add(new CalculationWorks.FreeEdition.BusinessModel.Behaviors.BcfParameterArraySetter<BcfSampleConsole.SumFunction, decimal>((fn, value) => fn.Values = value));
			}
			{
				// Segment.Size
				CalculationWorks.FreeEdition.BusinessModel.Design.BcfFunctionSetup f = segmentTableSizeColumn.SetFunction<BcfSampleConsole.MultiplyFunction>();
				f.AllowExecuteParallel = false;
				CalculationWorks.FreeEdition.BusinessModel.Design.BcfParameterSetup p1 = f.AddParameter("Value1", "Length");
				p1.BehaviorItems.Add(new CalculationWorks.FreeEdition.BusinessModel.Behaviors.BcfParameterValueSetter<BcfSampleConsole.MultiplyFunction, decimal>((fn, value) => fn.Value1 = value));
				CalculationWorks.FreeEdition.BusinessModel.Design.BcfParameterSetup p2 = f.AddParameter("Value2", "-CausewaySegment.Width");
				p2.BehaviorItems.Add(new CalculationWorks.FreeEdition.BusinessModel.Behaviors.BcfParameterValueSetter<BcfSampleConsole.MultiplyFunction, decimal>((fn, value) => fn.Value2 = value));
			}
		}
	}
}
